package x33eja.model;

import java.io.Serializable;
import javax.persistence.DiscriminatorColumn;
import javax.persistence.DiscriminatorType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Transient;

@Entity
@Table(name = "person")
@Inheritance(strategy=InheritanceType.JOINED)
//@DiscriminatorColumn(discriminatorType=DiscriminatorType.STRING,name="disc_type")
@DiscriminatorValue(value="person")
@DiscriminatorColumn(discriminatorType=DiscriminatorType.STRING, name="groupname")
@NamedQueries(
  @NamedQuery(name = Person.Q_GET_PERSON_BY_LOGIN, query = "SELECT p FROM Person p WHERE p.login=:login")
)
public class Person implements Serializable {

    @Transient
    public static final String Q_GET_PERSON_BY_LOGIN = "Person.GET_BY_LOGIN";
    
    /**
     * Protoze byl primarni klic zvolen nevhodne jako datum narozeni, musi
     * byt rucne osetreno, aby se neulozila duplicita, jinak nastane vyjimka:
     * java.sql.SQLIntegrityConstraintViolationException
     * Spravne generovani klice je naznaceno v entite Department
     */
    @Id
    private int birthNumber;

    private String firstName;

    private String surname;

    private String login;

    private String password;



    public String getLogin() {
        return login;
    }

    public void setLogin(String login) {
        this.login = login;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }


    public Person () {
    }

    public int getBirthNumber () {
        return birthNumber;
    }

    public void setBirthNumber (int val) {
        this.birthNumber = val;
    }

    public String getFirstName () {
        return firstName;
    }

    public void setFirstName (String val) {
        this.firstName = val;
    }

    public String getSurname () {
        return surname;
    }

    public void setSurname (String val) {
        this.surname = val;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Person other = (Person) obj;
        if (this.birthNumber != other.birthNumber) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 79 * hash + this.birthNumber;
        return hash;
    }

    
}

